#!/usr/bin/env python

import Pyro.core
import optparse
import sys

if __name__ == '__main__':
    Pyro.core.initClient(banner=0)
    parser = optparse.OptionParser()
    parser.add_option("-n", "--namespace", dest="object_namespace", default="ksearch_main",
                      help="Object name to register in NS")
    options, args = parser.parse_args()

    scheduler = Pyro.core.getProxyForURI("PYRONAME://:%s.scheduler"%options.object_namespace)

    for line in sys.stdin:
        url = line.strip()
        if not url.startswith("http://"):
            url = "http://" + url
        scheduler.put_front(url)
