import email
import nntplib
import re
import string
import sys
import urllib
import xmlrpclib

if len(sys.argv) != 3:
    print 'Usage: nntp.py board startnumber'
    sys.exit()

board = sys.argv[1]
number = sys.argv[2]

host = 'gurum.sparcs.org'
group = 'kaist.bbs.ara.' + board
uri_template = 'http://ara.kaist.ac.kr/viewarticle.php?grp=$group&no=$id'

xmlrpc_uri = 'http://localhost:80/api'
api_key = '54ebf56de7684dba0d69bffc9702e1b4'
source = 'ara'
encodings = ['cp949', 'latin1']

def try_decode(string):
    for encoding in encodings:
        try:
            return string.decode(encoding)
        except UnicodeDecodeError:
            pass

def process(string):
    string = try_decode(string)
    string = re.sub(r'[\x18]', '', string)
    return string.encode('utf-8')

uri_template = string.Template(uri_template)
xmlrpc = xmlrpclib.Server(xmlrpc_uri)
conn = nntplib.NNTP(host)
conn.group(group)

id = number
while True:
    article = conn.article(id)
    lines = article[3]
    string = '\r\n'.join(lines)
    message = email.message_from_string(string)
    uri = uri_template.substitute(locals())
    title = message['Subject']
    author = message['From']
    if message.is_multipart():
        for part in message.walk():
            if part.get_content_type() == 'text/plain':
                break
        message = part
    content = message.get_payload()
    title = process(title)
    author = process(author)
    content = author + process(content)
    result = xmlrpc.index(api_key, source, uri, title, content)
    print id, title, author
    sys.stdout.flush()
    try:
        id = conn.next()[1]
    except nntplib.NNTPError:
        break
