
from ksearch.frontend import framework

def get_handler(object_namespace='ksearch_main', debug=True):
    urls = [
            (r'^/$', 'handler.main'),
            (r'^/search$', 'handler.handle'), 
            (r'^/go$', 'handler.go'),
            (r'^/stat/?$', 'handler.stat'),
            (r'^/now/?$', 'handler.now'),
            (r'^/pages$', 'handler.pages'),
            (r'^/plot/?$', 'handler.plot'),
            (r'^/api$', 'handler.api'),
            (r'^/media/.+$', 'handler.media'),
            (r'^/feedback(/.*)?$', 'handler.feedback'),
            (r'^/about/?$', 'handler.about'),
            ]

    sf = framework.SimpleFramework(urls, debug=debug, namespace=object_namespace)

    return sf

handler = get_handler()
service_handler = get_handler('ksearch_service', debug=False)
