#!/usr/bin/env python

from __future__ import absolute_import

import thread_hack
import Pyro.core
import Pyro.naming
import Pyro.util

import optparse
import sys
import bsddb
import os
import threading
import time

sys.path.append(os.path.join(os.path.dirname(__file__), '..'))

from ksearch.crawler.queue import BTreeQueue
from ksearch.crawler.scheduler import Scheduler
from ksearch.crawler.downloader import Downloader

if __name__ == '__main__':
    Pyro.core.initClient(banner=0)

    parser = optparse.OptionParser()
    parser.add_option("-n", "--namespace", dest="object_namespace", default="ksearch_main",
                      help="Object name to register in NS")
    options, args = parser.parse_args()
    print "Args parsed:", repr(options.__dict__)

    print "Finding nameserver..."
    Pyro.core.initServer()
    ns=Pyro.naming.NameServerLocator().getNS()
    daemon=Pyro.core.Daemon()
    daemon.useNameServer(ns)

    indexer_service = Pyro.core.getProxyForURI("PYRONAME://:%s.indexer_service"%options.object_namespace)

    print "Optimizing index..."
    indexer_service.optimize()
    print "Optimizing complete."
