#!/usr/bin/env python
'''
DocIndexer PDF parser.
'''
import os, string, tempfile
from ksearch import util

class PdfParser(object):

    description = 'Xpdf document parser'
    mime_types = ['application/xpdf']

    def __init__(self):
        self.app_dir = os.path.join(
                            os.path.dirname(__file__),
                            "../../thirdparty/bin")
        self.app_path = os.path.join(
                            self.app_dir,
                            "pdftotext")
        self.app_path = "pdftotext"

    def text(self,str):
        fd, fn = tempfile.mkstemp(".pdf")
        f = open(fn, "w+b")
        f.write(str)
        f.close()
        ret = self.text_from_file(f.name)
        os.remove(f.name)
        return ret

    def text_from_file(self,filename):
        try:
            # Use short file names as the Windows command interpreter does not
            # like multiple quoted paths.
            cmd = "%s -enc UTF-8 -eol unix '%s' -"\
                    % (self.app_path, filename.replace("'", r"\'"))
            f = os.popen(cmd)
            text = f.read()
            err = f.close()
            if err is not None:
                raise Exception,'non-zero pdftotext exit status %d' % err
        except Exception:
            raise
        except:
            raise Exception,'unable to execute pdftotext'
        return util.smart_unicode(text)

# vim: ts=4 sw=4:
