%include "carrays.i"

%typemap(out) char ** {
  char **slist = $1;
  PyObject *pystr;
  PyObject *pyintid;
  PyObject *pyinttype;
  PyObject *pytuple;
  PyObject *pylist = PyList_New(0);
  while (*slist != NULL) {
    pystr = PyString_FromString(*slist);
    pyintid = PyInt_FromLong((long)*((unsigned char*)(*slist)-2));
    pyinttype = PyInt_FromLong((long)*((unsigned char*)(*slist)-1));
    //printf("%d:%c %s\n", *((*slist)-2), *((&slist)-2), *slist);
    pytuple = PyTuple_New(3);
    PyTuple_SetItem(pytuple, 0, pyintid);
    PyTuple_SetItem(pytuple, 1, pyinttype);
    PyTuple_SetItem(pytuple, 2, pystr);
    PyList_Append(pylist, pytuple);
    slist++;
  }
  $result = pylist;
}

%module ham
%{
#include "ham-py.h"
%}

extern HAM_RUNMODE *ham_open_index(char *optstr, char *filename);
extern char **ham_get_stems(char *sent, HAM_RUNMODE *mode);
%pythoncode %{
def ham_get_stems(sent, mode):
  if mode == None: raise TypeError("Mode is None")
  if isinstance(sent, str): sent = unicode(sent)
  if isinstance(sent, unicode): sent = sent.encode('cp949', 'replace')
  ret = _ham.ham_get_stems(sent, mode)
  ret = [(x[0], chr(x[1]), x[2].decode('cp949', 'replace')) for x in ret]
  return ret

def ham_get_stems_merged(sent, mode):
  ret = ham_get_stems(sent, mode)
  l = []
  last = -1
  asent = None
  for r in ret:
    if last != r[0]:
      if asent != None:
        l.append(asent)
      asent = []
    asent.append((r[1], r[2]))
    last = r[0]
  l.append(asent)

  return l
%}
extern int ham_close_index(HAM_RUNMODE *mode);
