#!/usr/bin/env python

import unittest
import sys
import os
import lucene

lucene.initVM(lucene.CLASSPATH)

PROJECT_PATH = os.path.dirname(os.path.abspath(__file__))
sys.path.append(os.path.join(PROJECT_PATH, ".."))

import ksearch.search.tests
import ksearch.parser.tests
import ksearch.crawler.tests

def suite():
    return unittest.TestSuite([ksearch.search.tests.suite(),
                               ksearch.parser.tests.suite(),
                               ksearch.crawler.tests.suite(),
                               ])

if __name__ == "__main__":
    try:
        import testoob
        testoob.main(defaultTest="suite")
    except ImportError:
        unittest.TextTestRunner().run(suite())
